unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, ExtCtrls, Menus,ShellApi, ComCtrls,Baza;


type
  TfrmGlowne = class(TForm)
    NotkiAktywne: TStringGrid;
    Funkcje: TGroupBox;
    Czas: TGroupBox;
    DodajN: TBitBtn;
    UsunN: TBitBtn;
    EdytujN: TBitBtn;
    KoniecN: TBitBtn;
    Dzien: TLabel;
    DzienWar: TLabel;
    Godzina: TLabel;
    GodzinaWar: TLabel;
    Timer: TTimer;
    PodreczneMenu: TPopupMenu;
    KoniecM: TMenuItem;
    EdycjaNotekM: TMenuItem;
    Kalendarz: TGroupBox;
    KlanedarzBr: TMonthCalendar;
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure KoniecMClick(Sender: TObject);
    procedure EdycjaNotekMClick(Sender: TObject);
    procedure KoniecNClick(Sender: TObject);
    procedure DodajNClick(Sender: TObject);
    procedure UsunNClick(Sender: TObject);
    procedure EdytujNClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
  procedure WndProc(var Msg : TMessage); override;
  public
    IconNotifyData : TNotifyIconData;
    procedure BabelkoweSort;
  end;


var
  frmGlowne: TfrmGlowne;

implementation

uses DodajN, Alert;

{$R *.DFM}


procedure TfrmGlowne.WndProc(var Msg : TMessage);
var
  p : TPoint;
begin
 if (Msg.Msg=WM_USER+1)and(Msg.lParam=WM_RBUTTONDOWN) then
 begin
  GetCursorPos(p);
  PodreczneMenu.Popup(p.x, p.y);
 end;

 if (Msg.Msg=WM_USER+1)and(Msg.lParam=WM_LBUTTONDBLCLK) then
 begin
 frmGlowne.show;
 end;

 inherited;
end;

procedure TfrmGlowne.FormCreate(Sender: TObject);
begin

 IloscAktywnych:=0;

 NotkiAktywne.ColWidths[0]:=100;
 NotkiAktywne.ColWidths[1]:=230;
 NotkiAktywne.ColWidths[2]:=70;
 NotkiAktywne.Cells[0,0]:='Aktywacja';
 NotkiAktywne.Cells[1,0]:='Nazwa';
 NotkiAktywne.Cells[2,0]:='Wano';
 DzienWar.Caption:=DateToStr(Date);
 GodzinaWar.Caption:=TimeToStr(Time);


with IconNotifyData do begin
   hIcon:=Application.Icon.Handle;
   uCallbackMessage:=WM_USER+1;
   cbSize:=SizeOf(IconNotifyData);
   Wnd:=Handle;
   uID:=100;
   uFlags:=NIF_MESSAGE+NIF_ICON+NIF_TIP;
end;
 StrPCopy(IconNotifyData.szTip, Application.Title);
 Shell_NotifyIcon(NIM_ADD,@IconNotifyData);
end;

procedure TfrmGlowne.TimerTimer(Sender: TObject);
var iPetla1,iPetla2    : Integer;
    BiezacaData        : TDateTime;

begin
 BiezacaData:=StrToDateTime(DateToStr(Date)+' '+TimeToStr(Time));

 for iPetla1:=1 to IloscAktywnych do  begin
   if TablicaAktywnych[iPetla1].DataN=BiezacaData then
    begin
    if frmAlert=nil then
     begin
     AlertRecord:=iPetla1;
     frmAlert:= TfrmAlert.Create(Application);
     frmAlert.ShowModal;
     frmAlert.Destroy;
     frmAlert:=nil;
     TablicaAktywnych[AlertRecord]:=TablicaAktywnych[IloscAktywnych];
     dec(IloscAktywnych);
     BabelkoweSort;
    end else
    begin
    frmAlert.OdswiezNotke(iPetla1);
    end;
   end;
  end;
 GodzinaWar.Caption:=TimeToStr(Time);
end;

procedure TfrmGlowne.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caNone;
  frmGlowne.Hide;
end;

procedure TfrmGlowne.KoniecMClick(Sender: TObject);
begin
  Shell_NotifyIcon(NIM_DELETE, @IconNotifyData);
  Application.ProcessMessages;
  Application.Terminate;
end;

procedure TfrmGlowne.EdycjaNotekMClick(Sender: TObject);
begin
 frmGlowne.show;
end;

procedure TfrmGlowne.KoniecNClick(Sender: TObject);
begin
  Shell_NotifyIcon(NIM_DELETE, @IconNotifyData);
  Application.ProcessMessages;
  Application.Terminate;
end;

procedure TfrmGlowne.DodajNClick(Sender: TObject);
begin

 if (IloscAktywnych<13) then begin

 Inc(IloscAktywnych);
 TablicaAktywnych[IloscAktywnych].WaznoscN:=0;
 TablicaAktywnych[IloscAktywnych].TloN:=ExtractFilePath(Application.ExeName)+'tlo.bmp';
 TablicaAktywnych[IloscAktywnych].DzwiekN:='';
 TablicaAktywnych[IloscAktywnych].TekstN:='';
 TablicaAktywnych[IloscAktywnych].DataN:=0;
 TablicaAktywnych[IloscAktywnych].NazwaN:='';
 BiezacyRecord:=IloscAktywnych;

 frmDodajN := TfrmDodajN.Create(Application);

 if frmDodajN.ShowModal= mrOK then
  begin
  NotkiAktywne.Cells[0,IloscAktywnych]:=DateTimeToStr(frmDodajN.NotkaDodawana.DataN);
  NotkiAktywne.Cells[1,IloscAktywnych]:=frmDodajN.NotkaDodawana.NazwaN;
   Case frmDodajN.NotkaDodawana.WaznoscN of
   0 :   NotkiAktywne.Cells[2,IloscAktywnych]:='Mao wane';
   1 :   NotkiAktywne.Cells[2,IloscAktywnych]:='rednio wane';
   2 :   NotkiAktywne.Cells[2,IloscAktywnych]:='Bardzo wane';
   end;
  TablicaAktywnych[IloscAktywnych]:=frmDodajN.NotkaDodawana;
  end else Dec(IloscAktywnych);
 frmDodajN.Destroy;
 end;
end;

procedure TfrmGlowne.UsunNClick(Sender: TObject);
var iPetla    : Integer;

begin
if (IloscAktywnych>0) and (NotkiAktywne.Selection.Top<=IloscAktywnych) then
 begin
 TablicaAktywnych[NotkiAktywne.Selection.Top]:=TablicaAktywnych[IloscAktywnych];
 dec(IloscAktywnych);
 BabelkoweSort;
 end;
end;

procedure TfrmGlowne.EdytujNClick(Sender: TObject);
begin
 if (IloscAktywnych>0) and (NotkiAktywne.Selection.Top<=IloscAktywnych) then begin
 BiezacyRecord:=NotkiAktywne.Selection.Top;
 frmDodajN := TfrmDodajN.Create(Application);
if frmDodajN.ShowModal= mrOK then
  begin
  NotkiAktywne.Cells[0,NotkiAktywne.Selection.Top]:=DateTimeToStr(frmDodajN.NotkaDodawana.DataN);
  NotkiAktywne.Cells[1,NotkiAktywne.Selection.Top]:=frmDodajN.NotkaDodawana.NazwaN;
   Case frmDodajN.NotkaDodawana.WaznoscN of
   0 :   NotkiAktywne.Cells[2,NotkiAktywne.Selection.Top]:='Mao wane';
   1 :   NotkiAktywne.Cells[2,NotkiAktywne.Selection.Top]:='rednio wane';
   2 :   NotkiAktywne.Cells[2,NotkiAktywne.Selection.Top]:='Bardzo wane';
   end;
  TablicaAktywnych[BiezacyRecord]:=frmDodajN.NotkaDodawana;
  end;
 frmDodajN.Destroy;
 end;
end;

procedure TfrmGlowne.BabelkoweSort;
var iPetla1,iPetla2 : Integer;
    tmpNotka        : TNotka;
begin

{Czyszczenie StringGrida}
 for iPetla1:=1 to 13 do
  begin
  NotkiAktywne.Cells[0,iPetla1]:='';
  NotkiAktywne.Cells[1,iPetla1]:='';
  NotkiAktywne.Cells[2,iPetla1]:='';
  end;

{Sortowanie babelkowe}
  for iPetla1:=1 to IloscAktywnych do
   for iPetla2:=IloscAktywnych downto iPetla1 do
      if (TablicaAktywnych[iPetla1].DataN<TablicaAktywnych[iPetla2].DataN) then
       begin
       tmpNotka:=TablicaAktywnych[iPetla1];
       TablicaAktywnych[iPetla1]:=TablicaAktywnych[iPetla2];
       TablicaAktywnych[iPetla2]:=tmpNotka;
       end;

{Wypelnianie StringGrida}
 for iPetla1:=1 to IloscAktywnych do
  begin
  NotkiAktywne.Cells[0,iPetla1]:=DateTimeToStr(TablicaAktywnych[iPetla1].DataN);
  NotkiAktywne.Cells[1,iPetla1]:=TablicaAktywnych[iPetla1].NazwaN;
   Case TablicaAktywnych[iPetla1].WaznoscN of
   0 :   NotkiAktywne.Cells[2,iPetla1]:='Mao wane';
   1 :   NotkiAktywne.Cells[2,iPetla1]:='rednio wane';
   2 :   NotkiAktywne.Cells[2,iPetla1]:='Bardzo wane';
   end;
  end;
end;


procedure TfrmGlowne.FormActivate(Sender: TObject);
begin
 Width:=Czas.Width+50;
 Height:=Czas.Height+NotkiAktywne.Height+50;
end;

end.
